diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/block-ack-type.h ns-3.43/src/wifi/model/block-ack-type.h
--- ns-3.42/src/wifi/model/block-ack-type.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/block-ack-type.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/block-ack-window.cc ns-3.43/src/wifi/model/block-ack-window.cc
--- ns-3.42/src/wifi/model/block-ack-window.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/block-ack-window.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/block-ack-window.h ns-3.43/src/wifi/model/block-ack-window.h
--- ns-3.42/src/wifi/model/block-ack-window.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/block-ack-window.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/capability-information.cc ns-3.43/src/wifi/model/capability-information.cc
--- ns-3.42/src/wifi/model/capability-information.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/capability-information.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/capability-information.h ns-3.43/src/wifi/model/capability-information.h
--- ns-3.42/src/wifi/model/capability-information.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/capability-information.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/channel-access-manager.cc ns-3.43/src/wifi/model/channel-access-manager.cc
--- ns-3.42/src/wifi/model/channel-access-manager.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/channel-access-manager.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -107,7 +96,7 @@
         }
     }
 
-    void NotifyTxStart(Time duration, double txPowerDbm) override
+    void NotifyTxStart(Time duration, dBm_u txPower) override
     {
         if (m_active)
         {
@@ -187,6 +176,15 @@
                           BooleanValue(false),
                           MakeBooleanAccessor(&ChannelAccessManager::SetGenerateBackoffOnNoTx,
                                               &ChannelAccessManager::GetGenerateBackoffOnNoTx),
+                          MakeBooleanChecker())
+            .AddAttribute("ProactiveBackoff",
+                          "Specify whether a new backoff value is generated when a CCA busy "
+                          "period starts, the backoff counter is zero and the station is not a "
+                          "TXOP holder. This is useful to generate a new backoff value when, "
+                          "e.g., the backoff counter reaches zero, the station does not transmit "
+                          "and subsequently the medium becomes busy.",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&ChannelAccessManager::m_proactiveBackoff),
                           MakeBooleanChecker());
     return tid;
 }
@@ -199,7 +197,6 @@
       m_lastRxReceivedOk(true),
       m_lastTxEnd(0),
       m_lastSwitchingEnd(0),
-      m_usingOtherEmlsrLink(false),
       m_sleeping(false),
       m_off(false),
       m_linkId(0)
@@ -249,26 +246,32 @@
 {
     NS_LOG_FUNCTION(this << phy);
 
-    if (auto phyListener = GetPhyListener(phy))
+    auto phyListener = GetPhyListener(phy);
+
+    if (phyListener)
     {
         // a PHY listener for the given PHY already exists, it must be inactive
         NS_ASSERT_MSG(!phyListener->IsActive(),
                       "There is already an active listener registered for given PHY");
         NS_ASSERT_MSG(!m_phy, "Cannot reactivate a listener if another PHY is active");
         phyListener->SetActive(true);
+        // if a PHY listener already exists, the PHY was disconnected and now reconnected to the
+        // channel access manager; unregister the listener and register again (below) to get
+        // updated CCA busy information
+        phy->UnregisterListener(phyListener);
     }
     else
     {
         phyListener = std::make_shared<PhyListener>(this);
         m_phyListeners.emplace(phy, phyListener);
-        phy->RegisterListener(phyListener);
     }
     if (m_phy)
     {
         DeactivatePhyListener(m_phy);
     }
     m_phy = phy; // this is the new active PHY
-    InitLastBusyStructs();
+    ResizeLastBusyStructs();
+    phy->RegisterListener(phyListener);
     if (phy->IsStateSwitching())
     {
         auto duration = phy->GetDelayUntilIdle();
@@ -359,43 +362,82 @@
 }
 
 void
-ChannelAccessManager::InitLastBusyStructs()
+ChannelAccessManager::ResizeLastBusyStructs()
 {
     NS_LOG_FUNCTION(this);
-    Time now = Simulator::Now();
-    m_lastBusyEnd.clear();
-    m_lastPer20MHzBusyEnd.clear();
-    m_lastIdle.clear();
-    m_lastBusyEnd[WIFI_CHANLIST_PRIMARY] = now;
-    m_lastIdle[WIFI_CHANLIST_PRIMARY] = {now, now};
+    const auto now = Simulator::Now();
+
+    m_lastBusyEnd.emplace(WIFI_CHANLIST_PRIMARY, now);
+    m_lastIdle.emplace(WIFI_CHANLIST_PRIMARY, Timespan{now, now});
+
+    const auto width = m_phy ? m_phy->GetChannelWidth() : 0;
+    std::size_t size =
+        (width > 20 && m_phy->GetStandard() >= WIFI_STANDARD_80211ax) ? width / 20 : 0;
+    m_lastPer20MHzBusyEnd.resize(size, now);
 
     if (!m_phy || !m_phy->GetOperatingChannel().IsOfdm())
     {
         return;
     }
 
-    uint16_t width = m_phy->GetChannelWidth();
-
     if (width >= 40)
     {
-        m_lastBusyEnd[WIFI_CHANLIST_SECONDARY] = now;
-        m_lastIdle[WIFI_CHANLIST_SECONDARY] = {now, now};
+        m_lastBusyEnd.emplace(WIFI_CHANLIST_SECONDARY, now);
+        m_lastIdle.emplace(WIFI_CHANLIST_SECONDARY, Timespan{now, now});
+    }
+    else
+    {
+        m_lastBusyEnd.erase(WIFI_CHANLIST_SECONDARY);
+        m_lastIdle.erase(WIFI_CHANLIST_SECONDARY);
     }
+
     if (width >= 80)
     {
-        m_lastBusyEnd[WIFI_CHANLIST_SECONDARY40] = now;
-        m_lastIdle[WIFI_CHANLIST_SECONDARY40] = {now, now};
+        m_lastBusyEnd.emplace(WIFI_CHANLIST_SECONDARY40, now);
+        m_lastIdle.emplace(WIFI_CHANLIST_SECONDARY40, Timespan{now, now});
     }
+    else
+    {
+        m_lastBusyEnd.erase(WIFI_CHANLIST_SECONDARY40);
+        m_lastIdle.erase(WIFI_CHANLIST_SECONDARY40);
+    }
+
     if (width >= 160)
     {
-        m_lastBusyEnd[WIFI_CHANLIST_SECONDARY80] = now;
-        m_lastIdle[WIFI_CHANLIST_SECONDARY80] = {now, now};
+        m_lastBusyEnd.emplace(WIFI_CHANLIST_SECONDARY80, now);
+        m_lastIdle.emplace(WIFI_CHANLIST_SECONDARY80, Timespan{now, now});
     }
+    else
+    {
+        m_lastBusyEnd.erase(WIFI_CHANLIST_SECONDARY80);
+        m_lastIdle.erase(WIFI_CHANLIST_SECONDARY80);
+    }
+
     // TODO Add conditions for new channel widths as they get supported
+}
+
+void
+ChannelAccessManager::InitLastBusyStructs()
+{
+    NS_LOG_FUNCTION(this);
+    Time now = Simulator::Now();
+
+    ResizeLastBusyStructs();
+
+    // reset all values
+    for (auto& [chType, time] : m_lastBusyEnd)
+    {
+        time = now;
+    }
+
+    for (auto& [chType, timeSpan] : m_lastIdle)
+    {
+        timeSpan = Timespan{now, now};
+    }
 
-    if (m_phy->GetStandard() >= WIFI_STANDARD_80211ax && width > 20)
+    for (auto& time : m_lastPer20MHzBusyEnd)
     {
-        m_lastPer20MHzBusyEnd.assign(width / 20, now);
+        time = now;
     }
 }
 
@@ -513,13 +555,14 @@
 {
     NS_LOG_FUNCTION(this);
     uint32_t k = 0;
-    Time now = Simulator::Now();
+    const auto now = Simulator::Now();
+    const auto accessGrantStart = GetAccessGrantStart();
     for (auto i = m_txops.begin(); i != m_txops.end(); k++)
     {
         Ptr<Txop> txop = *i;
         if (txop->GetAccessStatus(m_linkId) == Txop::REQUESTED &&
             (!txop->IsQosTxop() || !StaticCast<QosTxop>(txop)->EdcaDisabled(m_linkId)) &&
-            GetBackoffEndFor(txop) <= now)
+            GetBackoffEndFor(txop, accessGrantStart) <= now)
         {
             /**
              * This is the first Txop we find with an expired backoff and which
@@ -534,7 +577,7 @@
             {
                 Ptr<Txop> otherTxop = *j;
                 if (otherTxop->GetAccessStatus(m_linkId) == Txop::REQUESTED &&
-                    GetBackoffEndFor(otherTxop) <= now)
+                    GetBackoffEndFor(otherTxop, accessGrantStart) <= now)
                 {
                     NS_LOG_DEBUG(
                         "dcf " << k << " needs access. backoff expired. internal collision. slots="
@@ -602,58 +645,47 @@
 Time
 ChannelAccessManager::GetAccessGrantStart(bool ignoreNav) const
 {
-    NS_LOG_FUNCTION(this);
-    const Time& sifs = GetSifs();
-    Time rxAccessStart = m_lastRx.end + sifs;
+    NS_LOG_FUNCTION(this << ignoreNav);
+    auto rxAccessStart = m_lastRx.end;
     if ((m_lastRx.end <= Simulator::Now()) && !m_lastRxReceivedOk)
     {
         rxAccessStart += GetEifsNoDifs();
     }
     // an EDCA TXOP is obtained based solely on activity of the primary channel
     // (Sec. 10.23.2.5 of IEEE 802.11-2020)
-    Time busyAccessStart = m_lastBusyEnd.at(WIFI_CHANLIST_PRIMARY) + sifs;
-    Time txAccessStart = m_lastTxEnd + sifs;
-    Time navAccessStart = m_lastNavEnd + sifs;
-    Time ackTimeoutAccessStart = m_lastAckTimeoutEnd + sifs;
-    Time ctsTimeoutAccessStart = m_lastCtsTimeoutEnd + sifs;
-    Time switchingAccessStart = m_lastSwitchingEnd + sifs;
-    Time accessGrantedStart;
-    if (ignoreNav)
-    {
-        accessGrantedStart = std::max({rxAccessStart,
-                                       busyAccessStart,
-                                       txAccessStart,
-                                       ackTimeoutAccessStart,
-                                       ctsTimeoutAccessStart,
-                                       switchingAccessStart});
-    }
-    else
-    {
-        accessGrantedStart = std::max({rxAccessStart,
-                                       busyAccessStart,
-                                       txAccessStart,
-                                       navAccessStart,
-                                       ackTimeoutAccessStart,
-                                       ctsTimeoutAccessStart,
-                                       switchingAccessStart});
-    }
-    NS_LOG_INFO("access grant start=" << accessGrantedStart.As(Time::US)
-                                      << ", rx access start=" << rxAccessStart.As(Time::US)
-                                      << ", busy access start=" << busyAccessStart.As(Time::US)
-                                      << ", tx access start=" << txAccessStart.As(Time::US)
-                                      << ", nav access start=" << navAccessStart.As(Time::US)
-                                      << ", switching access start="
-                                      << switchingAccessStart.As(Time::US));
-    return accessGrantedStart;
+    const auto busyAccessStart = m_lastBusyEnd.at(WIFI_CHANLIST_PRIMARY);
+    const auto navAccessStart = ignoreNav ? Time{0} : m_lastNavEnd;
+
+    const auto accessGrantedStart = std::max({rxAccessStart,
+                                              busyAccessStart,
+                                              m_lastTxEnd,
+                                              navAccessStart,
+                                              m_lastAckTimeoutEnd,
+                                              m_lastCtsTimeoutEnd,
+                                              m_lastSwitchingEnd});
+
+    NS_LOG_INFO("access grant start="
+                << accessGrantedStart.As(Time::US)
+                << ", rx access start=" << rxAccessStart.As(Time::US) << ", busy access start="
+                << busyAccessStart.As(Time::US) << ", tx access start=" << m_lastTxEnd.As(Time::US)
+                << ", nav access start=" << navAccessStart.As(Time::US)
+                << ", switching access start=" << m_lastSwitchingEnd.As(Time::US));
+    return accessGrantedStart + GetSifs();
 }
 
 Time
-ChannelAccessManager::GetBackoffStartFor(Ptr<Txop> txop)
+ChannelAccessManager::GetBackoffStartFor(Ptr<Txop> txop) const
 {
-    NS_LOG_FUNCTION(this << txop);
-    Time mostRecentEvent =
+    return GetBackoffStartFor(txop, GetAccessGrantStart());
+}
+
+Time
+ChannelAccessManager::GetBackoffStartFor(Ptr<Txop> txop, Time accessGrantStart) const
+{
+    NS_LOG_FUNCTION(this << txop << accessGrantStart.As(Time::S));
+    const auto mostRecentEvent =
         std::max({txop->GetBackoffStart(m_linkId),
-                  GetAccessGrantStart() + (txop->GetAifsn(m_linkId) * GetSlot())});
+                  accessGrantStart + (txop->GetAifsn(m_linkId) * GetSlot())});
     NS_LOG_DEBUG("Backoff start for " << txop->GetWifiMacQueue()->GetAc() << ": "
                                       << mostRecentEvent.As(Time::US));
 
@@ -661,10 +693,17 @@
 }
 
 Time
-ChannelAccessManager::GetBackoffEndFor(Ptr<Txop> txop)
+ChannelAccessManager::GetBackoffEndFor(Ptr<Txop> txop) const
+{
+    return GetBackoffEndFor(txop, GetAccessGrantStart());
+}
+
+Time
+ChannelAccessManager::GetBackoffEndFor(Ptr<Txop> txop, Time accessGrantStart) const
 {
     NS_LOG_FUNCTION(this << txop);
-    Time backoffEnd = GetBackoffStartFor(txop) + (txop->GetBackoffSlots(m_linkId) * GetSlot());
+    Time backoffEnd =
+        GetBackoffStartFor(txop, accessGrantStart) + (txop->GetBackoffSlots(m_linkId) * GetSlot());
     NS_LOG_DEBUG("Backoff end for " << txop->GetWifiMacQueue()->GetAc() << ": "
                                     << backoffEnd.As(Time::US));
 
@@ -676,9 +715,10 @@
 {
     NS_LOG_FUNCTION(this);
     uint32_t k = 0;
+    const auto accessGrantStart = GetAccessGrantStart();
     for (auto txop : m_txops)
     {
-        Time backoffStart = GetBackoffStartFor(txop);
+        Time backoffStart = GetBackoffStartFor(txop, accessGrantStart);
         if (backoffStart <= Simulator::Now())
         {
             uint32_t nIntSlots = ((Simulator::Now() - backoffStart) / GetSlot()).GetHigh();
@@ -715,12 +755,13 @@
      * if there is one, how many slots for AIFS+backoff does it require ?
      */
     bool accessTimeoutNeeded = false;
-    Time expectedBackoffEnd = Simulator::GetMaximumSimulationTime();
+    auto expectedBackoffEnd = Simulator::GetMaximumSimulationTime();
+    const auto accessGrantStart = GetAccessGrantStart();
     for (auto txop : m_txops)
     {
         if (txop->GetAccessStatus(m_linkId) == Txop::REQUESTED)
         {
-            Time tmp = GetBackoffEndFor(txop);
+            Time tmp = GetBackoffEndFor(txop, accessGrantStart);
             if (tmp > Simulator::Now())
             {
                 accessTimeoutNeeded = true;
@@ -747,7 +788,7 @@
     }
 }
 
-uint16_t
+MHz_u
 ChannelAccessManager::GetLargestIdlePrimaryChannel(Time interval, Time end)
 {
     NS_LOG_FUNCTION(this << interval.As(Time::US) << end.As(Time::S));
@@ -762,7 +803,7 @@
     // also be called before starting a TXOP gained through EDCA.
     UpdateLastIdlePeriod();
 
-    uint16_t width = 0;
+    MHz_u width = 0;
 
     // we iterate over the different types of channels in the same order as they
     // are listed in WifiChannelListType
@@ -908,6 +949,21 @@
             m_lastPer20MHzBusyEnd[chIdx] = now + per20MhzDurations[chIdx];
         }
     }
+
+    if (m_proactiveBackoff)
+    {
+        // have all EDCAFs that are not carrying out a TXOP and have the backoff counter set to
+        // zero proactively generate a new backoff value
+        for (auto txop : m_txops)
+        {
+            if (txop->GetAccessStatus(m_linkId) != Txop::GRANTED &&
+                txop->GetBackoffSlots(m_linkId) == 0)
+            {
+                NS_LOG_DEBUG("Generate backoff for " << txop->GetWifiMacQueue()->GetAc());
+                txop->GenerateBackoff(m_linkId);
+            }
+        }
+    }
 }
 
 void
@@ -917,7 +973,6 @@
 
     Time now = Simulator::Now();
     NS_ASSERT(m_lastTxEnd <= now);
-    NS_ASSERT(m_lastSwitchingEnd <= now);
 
     if (phyListener) // to make tests happy
     {
@@ -947,6 +1002,12 @@
 
     ResetState();
 
+    // Cancel timeout
+    if (m_accessTimeout.IsPending())
+    {
+        m_accessTimeout.Cancel();
+    }
+
     // Reset backoffs
     for (const auto& txop : m_txops)
     {
@@ -974,12 +1035,6 @@
     m_lastCtsTimeoutEnd = std::min(m_lastCtsTimeoutEnd, now);
 
     InitLastBusyStructs();
-
-    // Cancel timeout
-    if (m_accessTimeout.IsPending())
-    {
-        m_accessTimeout.Cancel();
-    }
 }
 
 void
@@ -1014,13 +1069,9 @@
 {
     NS_LOG_FUNCTION(this);
     m_sleeping = true;
-    // Cancel timeout
-    if (m_accessTimeout.IsPending())
-    {
-        m_accessTimeout.Cancel();
-    }
-
     // Reset backoffs
+    ResetAllBackoffs();
+    m_feManager->NotifySleepNow();
     for (auto txop : m_txops)
     {
         txop->NotifySleep(m_linkId);
@@ -1134,20 +1185,6 @@
 }
 
 void
-ChannelAccessManager::NotifyStartUsingOtherEmlsrLink()
-{
-    NS_LOG_FUNCTION(this);
-    m_usingOtherEmlsrLink = true;
-}
-
-void
-ChannelAccessManager::NotifyStopUsingOtherEmlsrLink()
-{
-    NS_LOG_FUNCTION(this);
-    m_usingOtherEmlsrLink = false;
-}
-
-void
 ChannelAccessManager::UpdateLastIdlePeriod()
 {
     NS_LOG_FUNCTION(this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/channel-access-manager.h ns-3.43/src/wifi/model/channel-access-manager.h
--- ns-3.42/src/wifi/model/channel-access-manager.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/channel-access-manager.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -34,6 +23,7 @@
 #include <vector>
 
 class EmlsrUlTxopTest;
+class EmlsrCcaBusyTest;
 
 namespace ns3
 {
@@ -62,6 +52,7 @@
 {
     /// Allow test cases to access private members
     friend class ::EmlsrUlTxopTest;
+    friend class ::EmlsrCcaBusyTest;
 
   public:
     ChannelAccessManager();
@@ -158,6 +149,26 @@
     Time GetAccessGrantStart(bool ignoreNav = false) const;
 
     /**
+     * Return the time when the backoff procedure
+     * started for the given Txop.
+     *
+     * \param txop the Txop
+     *
+     * \return the time when the backoff procedure started
+     */
+    Time GetBackoffStartFor(Ptr<Txop> txop) const;
+
+    /**
+     * Return the time when the backoff procedure
+     * ended (or will end) for the given Txop.
+     *
+     * \param txop the Txop
+     *
+     * \return the time when the backoff procedure ended (or will end)
+     */
+    Time GetBackoffEndFor(Ptr<Txop> txop) const;
+
+    /**
      * \param qosTxop a QosTxop that needs to be disabled
      * \param duration the amount of time during which the QosTxop is disabled
      *
@@ -191,11 +202,10 @@
      *
      * \param interval the given time interval
      * \param end the given end time
-     * \return the width of the largest primary channel that has been idle for the
-     *         given time interval before the given time, if any primary channel has
-     *         been idle, or zero, otherwise
+     * \return the width of the largest primary channel that has been idle for the given time
+     * interval before the given time, if any primary channel has been idle, or zero, otherwise
      */
-    uint16_t GetLargestIdlePrimaryChannel(Time interval, Time end);
+    MHz_u GetLargestIdlePrimaryChannel(Time interval, Time end);
 
     /**
      * \param indices a set of indices (starting at 0) specifying the 20 MHz channels to test
@@ -301,15 +311,6 @@
     void NotifyCtsTimeoutResetNow();
 
     /**
-     * Notify that another EMLSR link is being used, hence medium access should be disabled.
-     */
-    void NotifyStartUsingOtherEmlsrLink();
-    /**
-     * Notify that another EMLSR link is no longer being used, hence medium access can be resumed.
-     */
-    void NotifyStopUsingOtherEmlsrLink();
-
-    /**
      * Check if the device is busy sending or receiving,
      * or NAV or CCA busy.
      *
@@ -359,33 +360,46 @@
      * \return the current registered listener for PHY events on the given PHY
      */
     std::shared_ptr<PhyListener> GetPhyListener(Ptr<WifiPhy> phy) const;
+
     /**
-     * Initialize the structures holding busy end times per channel type (primary,
-     * secondary, etc.) and per 20 MHz channel.
+     * Initialize the structures holding busy end times per channel type (primary, secondary, etc.)
+     * and per 20 MHz channel. All values are set to the current time.
      */
     void InitLastBusyStructs();
+
+    /**
+     * Resize the structures holding busy end times per channel type (primary, secondary, etc.)
+     * and per 20 MHz channel. If a value (e.g., the busy end time for secondary40 channel) already
+     * exists, it is not changed; otherwise, it is set to the current time.
+     */
+    void ResizeLastBusyStructs();
     /**
      * Update backoff slots for all Txops.
      */
     void UpdateBackoff();
+
     /**
-     * Return the time when the backoff procedure
-     * started for the given Txop.
+     * This overload is provided to enable caching the value returned by GetAccessGrantStart(),
+     * which is independent of the given Txop object.
      *
      * \param txop the Txop
+     * \param accessGrantStart the value returned by GetAccessGrantStart()
      *
      * \return the time when the backoff procedure started
      */
-    Time GetBackoffStartFor(Ptr<Txop> txop);
+    Time GetBackoffStartFor(Ptr<Txop> txop, Time accessGrantStart) const;
+
     /**
-     * Return the time when the backoff procedure
-     * ended (or will ended) for the given Txop.
+     * This overload is provided to enable caching the value returned by GetAccessGrantStart(),
+     * which is independent of the given Txop object.
      *
      * \param txop the Txop
+     * \param accessGrantStart the value returned by GetAccessGrantStart()
      *
-     * \return the time when the backoff procedure ended (or will ended)
+     * \return the time when the backoff procedure ended (or will end)
      */
-    Time GetBackoffEndFor(Ptr<Txop> txop);
+    Time GetBackoffEndFor(Ptr<Txop> txop, Time accessGrantStart) const;
+
     /**
      * This method determines whether the medium has been idle during a period (of
      * non-null duration) immediately preceding the time this method is called. If
@@ -404,6 +418,7 @@
      * (e.g. backoff procedure expired).
      */
     void AccessTimeout();
+
     /**
      * Grant access to Txop using DCF/EDCF contention rules
      */
@@ -415,12 +430,14 @@
      * \return the SIFS duration
      */
     virtual Time GetSifs() const;
+
     /**
      * Return the slot duration for this PHY.
      *
      * \return the slot duration
      */
     virtual Time GetSlot() const;
+
     /**
      * Return the EIFS duration minus a DIFS.
      *
@@ -456,7 +473,6 @@
     std::map<WifiChannelListType, Timespan>
         m_lastIdle;               //!< the last idle start and end time for each channel type
     Time m_lastSwitchingEnd;      //!< the last switching end time
-    bool m_usingOtherEmlsrLink;   //!< whether another EMLSR link is being used
     bool m_sleeping;              //!< flag whether it is in sleeping state
     bool m_off;                   //!< flag whether it is in off state
     Time m_eifsNoDifs;            //!< EIFS no DIFS time
@@ -465,6 +481,8 @@
                                   //!< right to start a TXOP but it does not transmit any frame
                                   //!< (e.g., due to constraints associated with EMLSR operations),
                                   //!< provided that the queue is not actually empty
+    bool m_proactiveBackoff; //!< whether a new backoff value is generated when a CCA busy period
+                             //!< starts and the backoff counter is zero
 
     /// Information associated with each PHY that is going to operate on another EMLSR link
     struct EmlsrLinkSwitchInfo
